HDU4411 最小费用流

题目:http://acm.hdu.edu.cn/showproblem.php?pid=4411

  1. floyd处理出最短路
  2. 每个点拆为i、i+n,i到i+n连一条容量为1,费用为负无穷的边,代表这个城市必须访问
  3. i+n到j(j>i)分别建边,容量为1,费用为i、j最短路
  4. i+n到汇点建立容量为1费用为g[0][i]的边,代表会警察局
  5. 0到i建立容量为1费用为g[0][i]的边
  6. 0到汇点建立容量为k,费用为0的边,代表有的警察可能一直待在警察局
  7. 源点到0建立容量为k费用为0的边

ps:这题会有重边,以后一定要注意,每道题都要判重!

 1 #include<bits/stdc++.h>
 2 using namespace std;
 3 const int inf = 0x3f3f3f3f;
 4 const int maxv = 222;
 5 typedef pair<int,int> P;
 6 struct edge{
 7     int to,cap,cost,rev;
 8 };
 9 int V;
10 vector<edge> g[maxv];
11 int h[maxv];
12 int dist[maxv];
13 int prevv[maxv],preve[maxv];
14 void addedge(int from,int to,int cap,int cost){
15     g[from].push_back(edge{to,cap,cost,g[to].size()});
16     g[to].push_back((edge{from,0,-cost,g[from].size()-1}));
17 }
18 int solve(int s,int t,int f){
19     int res = 0;
20     memset(h,0,sizeof(h)) ;
21     while(f > 0){
22         priority_queue<P,vector<P>,greater<P> > que;
23         memset(dist,inf,sizeof(dist));
24         dist[s] = 0;
25         que.push(P(0,s));
26         while(!que.empty()){
27             P p = que.top();
28             que.pop();
29             int v = p.second;
30             if(dist[v] < p.first)
31                 continue;
32             for(int i = 0;i<g[v].size();i++){
33                 edge &e = g[v][i] ;
34                 if(e.cap>0 && dist[e.to]>dist[v]+e.cost+h[v]-h[e.to]){
35                     dist[e.to] = dist[v]+e.cost+h[v]-h[e.to];
36                     prevv[e.to] = v;
37                     preve[e.to] = i;
38                     que.push(P(dist[e.to],e.to));
39                 }
40             }
41         }
42         if(dist[t] == inf)
43             return -1;
44         for(int i = 0;i<V;i++)
45             h[i] += dist[i];
46         int d = f;
47         for(int v = t;v!=s;v=prevv[v])
48             d = min(d,g[prevv[v]][preve[v]].cap);
49         f -= d;
50         res += d*h[t];
51         for(int v = t;v!=s;v = prevv[v]){
52             edge &e = g[prevv[v]][preve[v]];
53             e.cap -= d;
54             g[v][e.rev].cap += d;
55         }
56     }
57     return res;
58 }
59 int mp[111][111];
60 int main(){
61     int n,m,k;
62     while(scanf("%d%d%d",&n,&m,&k)){
63         if(!n && !m && !k)
64             break;
65         V = 2*n+3;
66         int s = 2*n+1,t = 2*n+2;
67         for(int i = 0;i<2*n+3;i++)
68             g[i].clear();
69         memset(mp,inf,sizeof(mp));
70         for(int i = 0;i<=n;i++)
71             mp[i][i] = 0;
72         int u,v,w;
73         while(m--){
74             scanf("%d%d%d",&u,&v,&w);
75             mp[u][v] = mp[v][u] = min(mp[u][v],w);
76         }
77         for(int k = 0;k<=n;k++)
78             for(int i = 0;i<=n;i++)
79                 for(int j = 0;j<=n;j++)
80                     mp[i][j] = min(mp[i][j],mp[i][k]+mp[k][j]);
81         for(int i = 1;i<=n;i++){
82             addedge(0,i,1,mp[0][i]);
83             addedge(i+n,t,1,mp[0][i]);
84             addedge(i,i+n,1,-111111);
85             for(int j = i+1;j<=n;j++){
86                 if(mp[i][j] != inf)
87                     addedge(i+n,j,k,mp[i][j]);
88             }
89         }
90         addedge(s,0,k,0);
91         addedge(0,t,k,0);
92         cout << solve(s,t,k)+n*111111 << endl;
93     }
94     return 0;
95 }
时间: 2024-12-08 21:09:46

HDU4411 最小费用流的相关文章

HDU 3488Tour(网络流之最小费用流)

题目地址:hdu3488 这题跟上题基本差不多啊....详情请戳这里. 另外我觉得有要改变下代码风格了..终于知道了为什么大牛们的代码的变量名都命名的那么长..我决定还是把源点与汇点改成source和sink吧..用s和t太容易冲突了...于是如此简单的一道题调试到了现在..sad... 代码如下: #include <iostream> #include <stdio.h> #include <string.h> #include <stdlib.h> #

【bzoj1834】[ZJOI2010]network 网络扩容 最大流+最小费用流

题目描述 给定一张有向图,每条边都有一个容量C和一个扩容费用W.这里扩容费用是指将容量扩大1所需的费用.求: 1. 在不扩容的情况下,1到N的最大流: 2. 将1到N的最大流增加K所需的最小扩容费用. 输入 输入文件的第一行包含三个整数N,M,K,表示有向图的点数.边数以及所需要增加的流量. 接下来的M行每行包含四个整数u,v,C,W,表示一条从u到v,容量为C,扩容费用为W的边. 输出 输出文件一行包含两个整数,分别表示问题1和问题2的答案. 样例输入 5 8 2 1 2 5 8 2 5 9

poj2135 最小费用流

添加超级源点(与点1之间的边容量为2,权值为0)和超级汇点(与点N之间的边容量为2,权值为0),求流量为2的最小费用流.注意是双向边. #include <iostream> #include <cstdio> #include <vector> #include <queue> using namespace std; const long long INF = 0x3f3f3f3f3f3f3f3f; typedef long long ll; typed

HDU 1533 Going Home(最小费用流)

Going Home Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 3278    Accepted Submission(s): 1661 Problem Description On a grid map there are n little men and n houses. In each unit time, every

FZU2143Board Game(最小费用流)

题目大意是说有一个B矩阵,现在A是一个空矩阵(每个元素都为0),每次操作可以将A矩阵相邻的两个元素同时+1,但是有个要求就是A矩阵的每个元素都不可以超过K,求 这个的最小值 解题思路是这样的,新建起点与奇点(i != j)连K条边,第i条边的权值为(i - B)^2 - (i - 1 - B)^2 = 2 * i - 1 - 2 * B(这样可以保证如果此边的流量为a, 花费始终是(a-b)^2);另外新建终点与偶点相连,代价与上诉一致: 然后跑一遍最小费用流,知道cost>=0时为止.祥见代码

HDU 1853Cyclic Tour(网络流之最小费用流)

题目地址:HDU1853 费用流果然好神奇..还可以用来判断环...如果每个点都是环的一部分而且每个点只能用到一次的话,那每个点的初度入度都是1,这就可以利用网络流来解决,只要拆点令其流量为1,就限制了每个点只能用一次,每次左边的连到右边的,就相当于左边点的一次初度和右边的点的一次入度,很容易想象出来.最后只要判断总流量是否为n即可,因为如果总流量为n的话,说明每个点都出了一次度,每个点都入了一次度,而且由于拆点的流量限制,充分说明了每个点的初度入度都是1.进而说明了每个点都在环里.然后输出最后

POJ 2135.Farm Tour 最小费用流

Farm Tour Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 17307   Accepted: 6687 Description When FJ's friends visit him on the farm, he likes to show them around. His farm comprises N (1 <= N <= 1000) fields numbered 1..N, the first of

Going Home (hdu 1533 最小费用流)

集训的图论都快结束了,我才看懂了最小费用流,惭愧啊. = = 但是今天机械键盘到了,有弄好了自行车,好高兴\(^o^)/~ 其实也不是看懂,就会套个模板而已.... 这题最重要的就是一个: 多组输入一定要写个init()函数清空,并且输入的时候每次都要调用init() #include <map> #include <set> #include <list> #include <cmath> #include <queue> #include &

POJ 3422 矩阵取数 最小费用流拆点+负边

Kaka's Matrix Travels Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 9153   Accepted: 3696 Description On an N × N chessboard with a non-negative number in each grid, Kaka starts his matrix travels with SUM = 0. For each travel, Kaka mo